#ifndef _hashtable_h
#define _hashtable_h

#define FALSE (0)
#define TRUE (!FALSE)

typedef unsigned char boolean;

struct hashtable_struct;
typedef struct hashtable_struct *hashtable;

void ht_delete(/*@only@*/ hashtable deleteme);
hashtable ht_new(unsigned int size, 
                 unsigned int (*hash)(const void *key),
                 boolean (*isequal)(const void *key1, 
                                    const void *key2), 
                 /*@null@*/ void (*free_key)(void *key),
                 /*@null@*/ void (*free_value)(void *value) );
void ht_insert(hashtable ht, 
               const void *key,
               const void *value);
void ht_remove(hashtable ht,
               const void *key);
void ht_free_entry(hashtable ht, 
               const void *key,
               const void *value);
/*@dependent@*/ /*@null@*/ 
const void *ht_lookup(hashtable ht,
                const void *key);
boolean ht_iterate(hashtable ht,
                boolean (*callback)(void *user, 
                                 const void *key, 
                                 const void *val),
                void *user);

#endif
